#include "common.h"
#include "ops.h"
Routine *routines;
FILE *logfile;
void readCode(long routine, long n, FILE *f)
{
   long i, x;
   int j;
   int opcode;
   routines[routine].code = new Instruction[n];
   //printf("%d: ",n);
   for (i = 0; i < n; i++)
   {
      opcode = fgetc(f);
      //printf("%d: ",opcode);
      routines[routine].code[i].opcode = opcode;
      routines[routine].code[i].args = new EuObject*[opcodes[opcode].nargs];
      for (j = 0; j < opcodes[opcode].nargs; j++)
      {
         if (opcodes[opcode].argtypes[j] == VAL) {
            //printf("Reading...\n");
                  routines[routine].code[i].args[j] = new EuObject();
                  routines[routine].code[i].args[j]->ReadValue(f);
                  //printf("%d(%d) ",routines[routine].code[i].args[j]->iVal,routines[routine].code[i].args[j]->type);
         }
         else {
              x = readInt(f);
              //printf("%d ",x);
              //printf("Linking...\n");
            routines[routine].code[i].args[j] = &vars[x-1];
         }
      }
      //printf("\n");
   }
   //printf("\n");
}
void readFile(FILE *f)
{
   long i;
   long nRoutines;
   i = readInt(f);
   //printf("%d vars\n",i);
   vars = new EuObject[i];
   nRoutines = readInt(f)+1;
   //printf("%d routines\n",nRoutines);
   routines = new Routine[nRoutines];
   for (i = 1; i < nRoutines; i++)
   {
      readCode(i,readInt(f),f);
   }
   readCode(0,readInt(f),f);
}
void runCode()
{
   ip = 0;
   rp = 0;
   while (1)
   {
      //fprintf(logfile,"%d:%d %d\n",rp,ip,routines[rp].code[ip].opcode);
      opcodes[routines[rp].code[ip].opcode].run(routines[rp].code[ip].args);
   }
}
